<?php
namespace Accounts\Permissions\Controller\Component;

use Cake\Controller\Component;
use Cake\Controller\ComponentRegistry;
use Cake\Core\Configure;
use Cake\Database\Expression\QueryExpression;
use Cake\ORM\Query;
use Cake\ORM\TableRegistry;

/**
 * CheckPermissions component
 */
class CheckPermissionsComponent extends Component
{

    /**
     * Default configuration.
     *
     * @var array
     */
    protected $_defaultConfig = [];

    public function initialize(array $config)
    {
        parent::initialize($config); // TODO: Change the autogenerated stub
        $this->isAuthorized();
    }

    public function isAuthorized()
    {
        $user = $this->getController()->request->getSession()->read('User');

        $plugin = $this->getController()->request->getParam('plugin');
        $controller = $this->getController()->request->getParam('controller');
        $action = $this->getController()->request->getParam('action');
        $extension = $this->getController()->request->getParam('_ext');

        $options = [
            'plugin' => $plugin,
            'controller' => $controller,
            'action' => $action,
            'extension' => $extension
        ];


        if ($user != null) {

            if ($user['role_id'] != ROLE_ADMIN) {
                $permissions = $this->getPermissions($user, $options);
                if ($permissions->count() == 0) {
                    $this->getController()->Flash->error(__d('Accounts/permissions', 'You are not authorized to access that location.'));
                    $this->redirect();
                }
            }
        }
    }

    private function getPermissions($user, $options = null)
    {
        if (!$options['plugin']) {
            $options['plugin'] = null;
        }
        if (!$options['controller']) {
            $options['controller'] = null;
        }
        if (!$options['action']) {
            $options['action'] = null;
        }
        $table = TableRegistry::get('Accounts/Permissions.Permissions');

        $permissions = $table->find('all', [
            'contain' => ['Roles']
        ])
            ->select([
                'Roles.name',
                'Permissions.prefix',
                'Permissions.plugin',
                'Permissions.controller',
                'Permissions.action',
                'Permissions.extension',
                'Permissions.allowed'
            ])
            ->where(['role_id' => $user['role_id']])
            ->where(function (QueryExpression $exp, Query $q) use ($options) {
                $condition = $exp->or_(['Permissions.plugin IN' => [$options['plugin'], '*']])
                    ->isNull('Permissions.plugin');
                return $condition;
            })
            ->where(['Permissions.controller IN' => [$options['controller'], '*']])
            ->where(['Permissions.action IN' => [$options['action'], '*']]);

        return $permissions;
    }

    public function redirect()
    {
        return $this->getController()->redirect([
            'plugin' => 'Infrastructure',
            'controller' => 'Occurrences',
            'action' => 'index'
        ]);
    }


}
